*-----------------------------------------------------------------------------*
	*-------------- Userprogramm wieder entfernen, da --------------*
	*-------------- zu altes Kickstart benutzt wird ----------------*
	*-------------- Mal kurz eine Message raushauen ----------------*
NoKickstart20:	move.l	DTG_Dosbase(a5),a6
		lea	Kickstart20Path(pc),a0
		move.l	a0,d1
		move.l	#1005,d2			;Mode_OldFile
		jsr	_LVOOpen(a6)
		tst.l	d0
		beq.s	.NoHandle
		move.l	d0,d6
		move.l	d0,d1

	*------------ Text ausgeben --------------*
		lea	Kickstart20Text(pc),a0
		move.l	a0,d2
		moveq	#Kickstart20TextLen,d3
		jsr	_LVOWrite(a6)

	*---------- warte mal ein bischen --------*
		move.l	#250,d1				;~5 Sekunden warten
		jsr	_LVODelay(a6)

	*-------- Fenster wieder closen ----------*
		move.l	d6,d1
		jsr	_LVOClose(a6)
.NoHandle:	bra.w	NoEaglePlayer

*-----------------------------------------------------------------------------*
ClrPuffer:	move.l	a5,a0
		move.w	#PufferEnd-1,d0
.clr		clr.b	(a0)+
		dbf	d0,.clr
CopyEPBase:	move.l	EUS_Structure+EUS_EPBase(pc),a0
		move.l	a0,EPBase(a5)
		move.w	#EPG_SizeOf/2-1,d0
		move.l	a5,a1
.CopyEP:	move.w	(a0)+,(a1)+
		dbf	d0,.CopyEP
		rts

	if Executable+Debugger
*-----------------------------------------------------------------------------*
ClearUserMessage:movem.l d0/a1,-(a7)
		lea	MyMessage(a5),a1	;Messageadresse
		moveq	#UM_SizeOf>>1-1,d0
.Clr:		clr.w	(a1)+
		dbf	d0,.Clr
		movem.l	(a7)+,d0/a1
		rts

*-----------------------------------------------------------------------------*
CreateMsgPort:	pushlibs
		move.l	MsgPort(a5),d0
		bne.s	.PortOk
		move.l	4.w,a6
		jsr	_LVOCreateMsgPort(a6)	;Messageport auf die schnelle Art
		move.l	d0,MSGport(a5)
		tst.l	d0
		beq.s	.PortOk
		move.l	d0,a0
		move.l	#MyMsgPortName,LN_Name(a0)

	*----------- SignalBits setzen ------------*
		move.l	SignalBits(a5),d6
		moveq	#0,d0
		move.b	15(a0),d0
		bset	d0,d6
		move.l	d6,SignalBits(a5)

.PortOk:	poplibs
		move.l	MsgPort(a5),d0
		move.l	d0,a0
		tst.l	d0
		rts

*-----------------------------------------------------------------------------*
RemoveMsgPort:	pushlibs
		move.l	MSGport(a5),d0
		beq.s	.PortOk
		move.l	d0,a0

	*----------- SignalBits sperren ------------*
		move.l	SignalBits(a5),d1
		moveq	#0,d0
		move.b	15(a1),d0
		bclr	d0,d1
		move.l	d1,SignalBits(a5)

		clr.l	MsgPort(a5)
		move.l	4.w,a6
		jsr	_LVODeleteMsgPort(a6)	;Messageport auf die schnelle Art
.PortOk:	poplibs
		rts

*----------------------- Gibt die Return-Structure frei -------------------*
FreeCommandStruct:movem.l d0/d1/a0/a1/a4/a6,-(a7)
		move.l	UPrg_Struct(a5),a4
.NextStruct:	moveq	#0,d0
		cmp.l	a4,d0
		beq.w	.Return
		move.l	a4,a1
		move.l	(a1),a4
		move.l	EPT_StringSize(a1),d1
		beq.s	.StructFree
		move.l	4.w,a6
		jsr	_LVOFreeMem(a6)
.StructFree:	bra.b	.NextStruct
.Return:	movem.l	(a7)+,d0/d1/a0/a1/a4/a6
		rts
	endc

*----------------------- Setze Free-Struct in die Globals --------------------*
SetFreeStruct:	lea	FreeTable(a5),a0
		move.l	a0,EUS_Structure+EUS_FreeTable
		move.l	#EUSM_Window,FSWindow(a5)
		move.l	#EUSM_VisualInfo,FSVisualInfo(a5)
		move.l	#EUSM_PubScreenAdr,FSPubScreenAdr(a5)
	if	EID_MenuPic
		move.l	#EUSM_MenuStrip,FSMenuAdr(a5)
	endc
	if	EID_GadgetDown+EID_GadgetUp
		move.l	#EUSM_GadgetAdr,FSGadgetAdr(a5)
	endc
	if	withlistview
		move.l	#EUSM_MemListAdr,FSListAdr(a5)
		lea	ListViewStruct(a5),a0
		move.l	a0,FSListAdr+4(a5)
	endc
		rts



*---------------------------------------------------------------------------*
*------------------ Es wurde ein Break-Signal geschickt --------------------*
*------------------------ Hauptroutine wird verlassen ----------------------*
QuitUserProgramm:moveq	#0,d1
		moveq	#USClass_Exit,d2
		moveq	#0,d3
		moveq	#0,d4
		moveq	#0,d5
		bsrif	SendeOneMessage,Executable+Debugger
		move.w	#1,ExitNow(a5)
		rts

*---------------------------------------------------------------------------*
Hide:		ifeq	executable+debugger
		move.w	#1,ExitNow(a5)
		endc
		moveq	#0,d1
		moveq	#USClass_Deactivate,d2
		moveq	#0,d3
		moveq	#0,d4
		moveq	#0,d5
		bsrif	SendeOneMessage,Executable+Debugger
		rts


*---------------------------------------------------------------------------*
About:		movem.l	d0-a6,-(a7)

		moveq	#0,d1
		moveq	#USClass_LockEP,d2
		moveq	#0,d3
		moveq	#0,d4
		moveq	#0,d5
		bsrif	SendeOneMessage,Executable+Debugger

	if	executable+Debugger
		move.l	EUS_Structure+EUS_EPBase(pc),a4
		lea	AboutUPrg.Msg(pc),a1
		move.l	a1,EPG_Arg1(a4)
		move.l	EPG_PubScreen(a4),EPG_Arg2(a4)
		clr.l	EPG_Arg3(a4)
		subq.l	#1,EPG_Arg3(a4)			;X-Koordinate
		lea	About_Gadgets(pc),a0
		move.l	a0,EPG_Arg4(a4)
		lea	MyEasyTitle(pc),a0
		move.l	a0,EPG_Arg5(a4)
		clr.l	EPG_Arg6(a4)
		moveq	#-1,d0
		move.l	d0,EPG_Arg7(a4)
		moveq	#7,d0
		move.l	d0,EPG_ArgN(a4)
		jsr	ENPP_TextRequest(a4)
	else
		move.l	WinHandle(a5),a0	;Window
		lea	About_EasyStruct(pc),a1	;EasyStruct
		sub.l	a2,a2			;IDCMP_Ptr
		sub.l	a3,a3			;Arguments
		move.l	DTG_IntuitionBase(a5),a6
		jsr	_LVOEasyRequestArgs(a6)
	endc

		moveq	#0,d1
		moveq	#USClass_UnLockEP,d2
		moveq	#0,d3
		moveq	#0,d4
		moveq	#0,d5
		bsrif	SendeOneMessage,Executable+Debugger

		movem.l	(a7)+,d0-a6
		rts


*----------------------------- Gadget wurde losgelassen ----------------------*
		if	EID_GadgetUp
GadUp:		move.l	d5,a1
		moveq	#0,d0
		move.w	GG_GadgetID(a1),d0
		bra.w	JumpTo
		endc

*------------------------ Es wurde eine Taste gedrckt -----------------------*
		if	EID_VanillaKey
		ifeq	OwnVanillaKey
VanillaTaste:
	*------ Bei Vanillakey die Buchstaben nach Shift umbauen -----*
	*--- ConvertToAscii 
		moveq	#0,d3
		move.w	d4,d3
		move.w	d2,d0
		and.w	#-4,d0
		cmp.w	d2,d0
		beq.s	.NoShift
		cmp.w	#"a",d3
		blo.s	.NoShift
		cmp.w	#"z",d3
		bhi.s	.NoShift
		sub.w	#$20,d3

.NoShift:	lea	TastaturTabelle(pc),a3
.NextTest:	move.b	(a3)+,d1
		beq.w	Return
		move.b	(a3)+,d0
		cmp.b	d1,d3			;stimmt der AsciiCode
		bne.s	.NextTest
		bra.w	JumpTo
		endc
		endc


*---------------------------- Pull-Down-Menu aktiviert -----------------------*
		if	EID_MenuPic
Pullmenu:	clr.w	ItemAddi(a5)
		move.l	WinMenuAdr(a5),d1
		beq.w	Return
		move.l	d1,a0
		move.l	d4,d0
		beq.w	Return
		move.w	d4,d7
		cmp.w	#-1,d0
		beq.w	Return
		move.l	DTG_IntuitionBase(a5),a6
		jsr	_LVOItemAddress(A6)
		tst.l	d0
		beq	Return
		move.l	d0,a1
		move.w	MI_NextSelect(a1),ItemAddi(a5)

	*----------- MenuJumpTabelle durchgehen ------------*
	* in der Tabelle befinden sich in Reihenfolge die   *
	* Nummer der Aktionen fr JumpTo		    *
	*---------------------------------------------------*
		lea	MenuNummernOverTab(pc),a0		;Tabelle fr Menu 1
		move.l	d7,d6
.FindMenu:	move.w	(a0)+,d5
		and.b	#31,d6
		beq.w	.MenuOk
		subq.b	#1,d6
		bra.s	.FindMenu

.MenuOk:	lea	(a0,d5.w),a0
		and.w	#$7e0,d7
		lsr.l	#5,d7
		add.w	d7,d7
		move.w	(a0,d7),d0			;AktionsNummer
		bra.w	JumpTo
		endc


******************************************************************************
*---------------- Auswertung einer UserProgram-Message ----------------------*
******************************************************************************
*
*	Achtung 2. Ausgang der Routine bei Exit !!!!!!!!!!!!
*	Achtung 3. Ausgang der Routine bei UserQuitEagle !!!!!!!!!!!!
*
UserMessage:	if Executable+Debugger
	;	lea	TextPuffer(a5),a0		;Sicherheitshalber
		move.l	d0,a1
		cmp.l	#USM_UserPrg,UM_Type(a1) ;Test auf Analyzer-MSG
		beq.w	.Auswertung
		cmp.l	#USM_Eagleplayer,UM_Type(a1) ;Test auf Analyzer-MSG
		bne.w	.ReplyIt3

	*--------------- Es ist ein Message angekommen ------------*
.Auswertung:	moveq	#0,d0
		move.w	UM_UserNr(a1),d0

		move.l	UM_ArgString(a1),UPrg_Struct(a5)
		moveq	#0,d0
		moveq	#0,d7
		move.w	UM_Class(a1),d7
		beq.w	.ReplyIt
		cmp.w	#USClass_NewUserPrg,d7
		beq.w	.NewConfig			;.NewUserPrg
		cmp.w	#USClass_Activate,d7
		beq.w	.OpenWindow
		cmp.w	#USClass_DeActivate,d7
		beq.w	.CloseWindow
	if	ClassZipWindow
		cmp.w	#USClass_ZipWin,d7
		beq.w	.ZipWindow
		cmp.w	#USClass_UnZipWin,d7
		beq.w	.UnZipWindow
	endc
		cmp.w	#USClass_NewConfig,d7
		beq.w	.NewConfig
		cmp.w	#USClass_GetConfig,d7
		beq.w	.GetConfig
		cmp.w	#USClass_Exit,d7
		beq.w	.Exit
	if	ClassNewModule
		cmp.w	#USClass_NewModule,d7
		beq.s	.NewModule
	endc
	if	ClassNewDirectory
		cmp.w	#USClass_NewDirectory,d7
		beq.s	.NewDirectory
	endc
	if	ClassNewScrollText
		cmp.w	#USClass_NewScrollText,d7
		beq.s	.NewScrollText
	endc
	;	cmp.w	#USClass_Command,d7
	;	beq.w	.UserCommand
	;	cmp.w	#USClass_Answer,d7
	;	beq.s	.UserAnswer
	;	cmp.w	#USClass_QuitEagle,d7
	;	beq.s	.UserQuitEagle
	;	move.w	d7,d0
		moveq	#0,d0
		bra.w	.ReplyIt

	*------ Es wurde ein neues Module geladen -------*
	if	ClassNewModule
.NewModule:	bsr.w	FillListViews
		bra.s	.ReplyIt
	endc

	*----- Es wurde ein neues Directory geladen -----*
	if	ClassNewDirectory
.NewDirectory:	bsr.w	FillListViews
		moveq	#USClass_NewDirectory,d0
		bra.s	.ReplyIt
	endc

	*-------- Es wird ein neuer Text gescollt -------*
	if	ClassNewScrollText
.NewScrollText:	bsr.w	InsertScrollText
		bra.s	.ReplyIt
	endc

	*------- Ankommende Message sagt : "EXIT" -------*
.Exit:		move.w	#1,ExitNow(a5)
		bra.s	.ReplyIt		;Message replyen

	*----- Es wurde ein neue Config eingestellt -----*
.NewConfig:	move.w	EUS_Structure+EUS_Flags(pc),d0
		btst	#EUSF_Openwin,d0
		beq.s	.CloseWindow
	if ClassZipWindow
		btst	#EUSF_ZipWin,d0
		bne.s	.ZipWindow
	endc
		bra.s	.OpenWindow

	*- Der Eagleplayer mchte gerne die Config haben -*
.GetConfig:	lea	EUS_Structure(pc),a2
		moveq	#0,d0
		move.l	WinHandle(a5),d1
		beq.s	.GetNoWindow
		or.w	#EUSB_OpenWin,d0
		move.l	d1,a0
		move.l	4(a0),EUS_WinX(a2)

		bsr.w	GetSizeToSpecial
	if	ClassZipWindow
		move.w	10(a0),d1
		cmp.b	55(a0),d0		;Hhe vergleichen
		bne.s	.GetNoWindow
		or.w	#EUSB_ZipWin,d0
	endc
.GetNoWindow:	move.w	d0,EUS_Flags(a2)
		moveq	#USClass_GetConfig,d0
		bra.s	.ReplyIt

	*------ Ankommende Message sagt : "CLOSE MY WINDOW" -----*
.CloseWindow:	bsr	CloseMyWindow
		moveq	#USClass_DeActivate,d0
		bra.s	.ReplyIt
				
	*------ Angekommende Message sagt : "OPEN MY WINDOW" -----*
.OpenWindow:	bsr.w	OpenMyWindow
		moveq	#USClass_Activate,d0
		tst.l	WinHandle(a5)
		bne.s	.ReplyIt
		moveq	#USClass_Deactivate,d0
	if ClassZipWindow
		bra.w	.ReplyIt

	*------ Ankommende Message sagt : "Zip my Window" -------*
.ZipWindow:	bsr.w	ZipMyWindow
		moveq	#USClass_ZipWin,d0
		bra.s	.ReplyIt

	*------ Ankommende Message sagt : "UnZip my Window" -----*
.UnZipWindow:	bsr.w	UnZipMyWindow
		moveq	#USClass_UnZipWin,d0
	endc


	*------- Message frs Replyen vorbereiten ------*
	*----------------- Class setzen ----------------*
.ReplyIt:	bsr.w	FreeCommandStruct
		move.l	a1,d1
		beq.s	.NoMSG
		move.l	a1,a0
		move.l	UM_StructAdr(a1),StructAdr(a5)
		move.w	d0,UM_Class(a1)			;Dummy setzen
.ReplyIt3:	move.l	a1,d0
		beq.s	.NoMSG
		move.l	MSgPort(a5),a0
		cmp.l	14(a1),a0		;Reply-Port vergleichen
		beq.w	.ClearMerk
		move.l	4.w,a6
		jsr	_LVOReplymsg(a6)
.NoMSG:		rts

.ClearMerk:	subq.l	#1,MsgUnterwegs(a5)
		endc
Return:		rts


*-----------------------------------------------------------------------------*
*-----				Open Window				------*
*-----------------------------------------------------------------------------*
OpenMyWindow:	movem.l	d1-a6,-(a7)
		tst.l	Winhandle(a5)
		bne.w	.Return

	*----------- Publicscreen allokieren ------------*
		bsr	LockPubScreen		;Public Screen holen
		beq.w	.Return

	*----------- Menus und Gadgets erzeugen ---------*
		bsrif	CreateGadgets,EID_GadgetDown+EID_GadgetUp
		beqif	.CloseAll,EID_GadgetDown+EID_GadgetUp
		bsrif	CreateMenus,EID_MenuPic
		beqif	.CloseAll,EID_MenuPic

	*----------------- Window ffnen ----------------*
		moveq	#11,d1
		move.l	PubScreenAdr(a5),d0
		beq.s	.NoPubScreen
		move.l	d0,a0
		move.l	SC_Font(a0),a0
		move.w	TA_YSize(a0),d1
		addq.w	#3,d1
.NoPubScreen:	lea	WindowTags(pc),a1
		move.w	d1,WinHoehe(a5)
		move.l	MyFirstGadget(a5),MyWa_Gadgets-WindowTags+4(a1)
	if ZoomStruct
		move.w	d1,WindowZoom+6-WindowTags(a1)
	endc
		move.l	PubscreenAdr(a5),MyWA_PubScreenAdr-WindowTags+4(a1)
		move.w	EUS_Structure+EUS_WinX(pc),MyWA_Left-WindowTags+6(a1)
		move.w	EUS_Structure+EUS_WinY(pc),MyWA_Top-WindowTags+6(a1)
	if	Inner_Special
		move.l	EUS_Structure+EUS_Special(pc),d0
		bne.s	.SpecialZero
		move.w	#WindowInnerWidth,(EUS_Structure+EUS_Special)-WindowTags(a1)
		move.w	#WindowInnerHeight,(EUS_Structure+EUS_Special+2)-WindowTags(a1)
.SpecialZero:	move.w	EUS_Structure+EUS_Special(pc),MyWA_InnerWidth-WindowTags+6(a1)
		move.w	EUS_Structure+EUS_Special+2(pc),MyWA_InnerHeight-WindowTags+6(a1)
	endc
		sub.l	a0,a0
		move.l	DTG_Intuitionbase(a5),a6
		jsr	_LVOOpenWindowTagList(a6)
		move.l	d0,Winhandle(a5)
		tst.l	d0
		bne	.WindowOk


	*----------------- Window ffnen ----------------*
		lea	WindowTags(pc),a1
		move.l	PubscreenAdr(a5),MyWA_PubScreenAdr-WindowTags+4(a1)
		clr.l	MyWA_Left-WindowTags+4(a1)
		clr.l	MyWA_Top-WindowTags+4(a1)
	if	EWF_SizeBright+EWF_SizeBottom
		move.w	#WindowInnerWidth,MyWA_InnerWidth-WindowTags+6(a1)
		move.w	#WindowInnerWidth,(EUS_Structure+EUS_Special)-WindowTags(a1)
		move.w	#WindowInnerHeight,MyWA_InnerHeight-WindowTags+6(a1)
		move.w	#WindowInnerHeight,(EUS_Structure+EUS_Special+2)-WindowTags(a1)
	endc
		sub.l	a0,a0
		move.l	DTG_Intuitionbase(a5),a6
		jsr	_LVOOpenWindowTagList(a6)
		move.l	d0,Winhandle(a5)


	*-------- Scrollbalken adden oder auch nicht --------*
.WindowOk:	tst.l	d0
		bne.s	.WindowOk2

	*-------- Menus und Gadgets wieder freigeben --------*
.CloseAll:	bsr.w	CloseMyWindow
		bra.s	.Return

	*-------------- Merkzellen in Globals setzen --------*
.WindowOk2:	move.l	WinHandle(a5),a0
		move.l	WD_RPort(a0),a1
		move.l	a1,WinRastPort(a5)
		move.l	WD_UserPort(a0),a0
		move.l	a0,WinMsgPort(a5)


	*--------------- SignalBits setzen ---------------*
		move.l	SignalBits(a5),d6
		moveq	#0,d0
		move.b	15(a0),d0
		bset	d0,d6
		move.l	d6,SignalBits(a5)

	*-------- Menu setzen und Window refeshen --------*
		bsrif	FillWindow,Raster
	if	AlwaysFillListView
		bsrif	FillListViews,WithListView
	else
		bsrif	FillListViews2,WithListView
	endc
		bsrif	SetMenuStrip,EID_MenuPic

		move.l	DTG_GadToolsBase(a5),a6
		move.l	Winhandle(a5),a0
		suba.l	a1,a1
		jsr	_LVOGT_RefreshWindow(a6)

		bsrif	UpDateWindow,OwnRefresh


.Return:	movem.l	(a7)+,d1-a6
		move.l	WinHandle(a5),d0
		rts


*----------------------------------------------------------------------------*
*-----			Window schlieen und Positionen merken		-----*
*----------------------------------------------------------------------------*
*----------------------------------------------------------------------------*
CloseMyWindow:	movem.l	d0-a6,-(a7)
		move.l	Winhandle(a5),d0
		beq.s	.NoWindow
		move.l	d0,a0

		lea	EUS_Structure(pc),a1
		move.w	WD_LeftEdge(a0),EUS_WinX(a1)
		move.w	WD_TopEdge(a0),EUS_WinY(a1)
		bsrif	GetSizeToSpecial,Inner_Special


	*------------- Signalbits lschen ------------*
		move.l	WinHandle(a5),a0
		move.l	86(a0),a1			;MsgPort des Windows
		move.l	SignalBits(a5),d1
		moveq	#0,d0
		move.b	15(a1),d0
		bclr	d0,d1
		move.l	d1,SignalBits(a5)


		clr.l	WinHandle(a5)
		clr.l	WinRastport(a5)
		clr.l	WinMSGPort(a5)
		move.l	DTG_Intuitionbase(a5),a6
		jsr	_LVOCloseWindow(a6)

	*-------- Alle Variablen und Strukturen freigeben ---------*
.NoWindow:	bsrif	FreeMenus,EID_MenuPic
		bsrif	FreeGadgets,EID_GadgetDown+EID_GadgetUp
		bsr.w	FreePubScreen

		movem.l	(a7)+,d0-a6
		rts


*-----------------------------------------------------------------------------*
		if	ClassZipWindow
ZipMyWindow:	pushlibs
		tst.l	WinHandle(a5)
		bne.s	.ChangeWindow

	*----------- Window-Strukture ndern ----------*
	*--- Blo wie die Hhe des Windows angeben ----*
		bsr.w	OpenMyWindow

	*-------------- Window nur unzippen -----------*
.ChangeWindow:	move.l	WinHandle(a5),d0
		beq.s	.Return
		move.l	d0,a0
		move.w	10(a0),d0
		cmp.b	55(a0),d0
		beq.s	.Return
		move.l	DTG_Intuitionbase(a5),a6
		jsr	_LVOZipWindow(a6)
.Return:	poplibs
		rts


*-----------------------------------------------------------------------------*
UnZipMyWindow:	pushlibs
		tst.l	WinHandle(a5)
		bne.s	.ChangeWindow

	*----------- Window-Strukture ndern ----------*
	*--- Blo wie die Hhe des Windows angeben ----*
		bsr.w	OpenMyWindow
		bra.s	.Return

	*-------------- Window nur unzippen -----------*
.ChangeWindow:	move.l	WinHandle(a5),a0
		move.w	10(a0),d0
		cmp.b	55(a0),d0
		bne.s	.Return
		move.l	DTG_Intuitionbase(a5),a6
		jsr	_LVOZipWindow(a6)
.Return:	poplibs
		rts
		endc


*----------------------------- Fill-Window -------------------------------*
		if raster+rectfill
FillWindow:	movem.l	d0-a6,-(a7)
		tst.l	WinHandle(a5)
		beq.w	.Return
		move.l	DTG_GfxBase(a5),a6

	*------------ Zeichenstifte festlegen -------------*
		move.l	WinRastport(a5),d0
		beq.w	.Return
		move.l	d0,a1				;Rastport
	if raster
		moveq	#1,d0
	else
		moveq	#0,d0
	endc
		jsr	_LVOSetAPen(a6)
		move.l	WinRastPort(a5),a1
		moveq	#0,d0
		jsr	_LVOSetBPen(a6)

	*-------------- Zeichenmodus festlegen -------------*
		move.l	WinRastport(a5),a1
		moveq	#1,d0			;RP_Jam2
		jsr	_LVOSetDRmd(a6)

	*-------------- RastPort initialisieren ------------*
	if raster
		move.l	WinRastport(a5),a1
		move.b	29(a1),d4			;rp_areaptsz(a1),d4
		move.l	8(a1),d5			;rp_areaptrn(a1),d5
		move.b	#1,29(a1)			;rp_areaptsz
		lea	FillMuster1(pc),a0
		move.l	a0,8(a1)		;rp_areaptrn
	endc

	*------------- erstes Rectfill ausfhren -----------*
		move.l	WinHandle(a5),a0
		moveq	#0,d0				;x1
		add.b	54(a0),d0

		moveq	#0,d1				;y1
		move.b	55(a0),d1

		moveq	#0,d2
		sub.b	56(a0),d2
		ext.w	d2
		add.w	8(a0),d2			;x2

		moveq	#0,d3
		sub.b	57(a0),d3
		ext.w	d3
		add.w	10(a0),d3			;y2
		subq.w	#1,d2
		subq.w	#1,d3

		jsr	_LVORectfill(a6)

	
	*-------------- RastPort zurcksetzen ------------*
	if	raster
		movem.l	d4-d5,-(sp)
		move.l	WinRastPort(a5),a1
		lea	FillMuster2(pc),a0
		move.l	a0,8(a1)			;rp_areaptrn
		move.l	WinHandle(a5),a0

		moveq	#HoriRandBorder,d6
		moveq	#VertiRandBorder,d7
		moveq	#0,d0				;x1
		add.b	54(a0),d0
		add.w	d6,d0

		moveq	#0,d1				;y1
		move.b	55(a0),d1
		add.w	d7,d1

		moveq	#0,d2
		sub.b	56(a0),d2
		ext.w	d2
		add.w	8(a0),d2			;x2
		sub.w	d6,d2

		moveq	#0,d3
		sub.b	57(a0),d3
		ext.w	d3
		add.w	10(a0),d3			;y2
		sub.w	d7,d3
		subq.w	#1,d2
		subq.w	#1,d3

		jsr	_LVORectFill(a6)
		
	*------ Koordinaten fr Schwarz setzen -----*
		move.l	WinHandle(a5),a0
		move.l	WinRastPort(a5),a1
		moveq	#11,d0			;X-Position
		moveq	#0,d1
		move.b	55(a0),d1		;y1
		addq.w	#4,d1
		jsr	_LVOMove(a6)
		movem.l	(Sp)+,d4-d5
		move.l	WinRastPort(A5),a1
		move.b	d4,29(a1)			;rp_areaptsz
		move.l	d5,8(a1)			;rp_areaptrn
		move.l	WinRastPort(A5),a1
		moveq	#0,d0
		jsr	_LVOSetAPen(a6)
	endc

	*---------------- Kick2.0 BevelBox zeichnen --------------*
	if BevelBox
		move.l	DTG_GadToolsBase(a5),a6
		move.l	WinHandle(a5),a0

		moveq	#HoriRandBorder,d6
		moveq	#VertiRandBorder,d7
		moveq	#0,d0				;x1
		add.b	54(a0),d0
		add.w	d6,d0

		moveq	#0,d1				;y1
		move.b	55(a0),d1
		add.w	d7,d1

		moveq	#0,d2
		sub.b	56(a0),d2
		ext.w	d2
		add.w	8(a0),d2			;x2
		sub.w	d6,d2

		moveq	#0,d3
		sub.b	57(a0),d3
		ext.w	d3
		add.w	10(a0),d3			;y2
		sub.w	d7,d3

		sub.w	d0,d2
		sub.w	d1,d3

		move.l	WinRastPort(a5),a0
		lea	BevelBoxTags(a5),a3		;Tags mssen auch nach
		move.l	a3,a1				;a3
		move.l	#GT_Visualinfo,(a3)
		move.l	VisualInfo(a5),4(a3)
		jsr	_LVODrawBevelBoxA(a6)
	endc

.Return:	movem.l	(a7)+,d0-a6
		rts
		endc


*----------------------------------------------------------------------------*
RefreshMyWindow:pushlibs

		bsrif	FillWindow,Raster+RectFill

		move.l	DTG_GadToolsBase(a5),a6
		move.l	WinHandle(a5),d0
		beq.s	.Return
		move.l	d0,a0
		sub.l	a1,a1
		jsr	_LVOGT_BeginRefresh(a6)

		move.l	WinHandle(a5),a0
		moveq	#1,d0
		jsr	_LVOGT_EndRefresh(a6)

		bsrif	UpDateWindow,OwnRefresh

		bsrif	RefreshList,WithListView

.Return:	poplibs
		rts

*----------------------------------------------------------------------------*
	if	EWF_SizeBright+EWF_SizeBottom
ReSizeMyWindow:

	if	withlistview
		movem.l	d0-a6,-(a7)
		bsrif	FillWindow,Raster+RectFill
		move.l	DTG_IntuitionBase(a5),a6
		move.l	WinHandle(a5),d0
		move.l	d0,a0
		beq.s	.Return
	if	Inner_Special
		lea	EUS_Structure+EUS_Special(pc),a2
		move.l	8(a0),(a2)
	endc

	*-------------- Letztes SystemGadget finden ---------------*
		move.l	WD_FirstGadget(a0),a2
.FindIt:	move.w	GG_GadgetType(a2),d0
		btst	#15,d0
		beq.s	.GadgetDa
		move.l	a2,d6
		move.l	(a2),a2
		bra.s	.FindIt
.GadgetDa:	move.l	WD_FirstGadget(a0),a1
		move.l	a1,d5				;firstSystemGadget

		moveq	#-1,d0
		jsr	_LVORemoveGList(a6)


		bsr.w	FreeGadgets
		bsr.w	CreateGadgets

		move.l	d5,a1				;FirstGadget
		move.l	d6,a0
		move.l	WinGadgetsAdr(a5),(a0)		;Ketten verbinden

		move.l	WinHandle(a5),a0
		moveq	#0,d0
		moveq	#-1,d1
		moveq	#0,d2
		move.l	DTG_IntuitionBase(a5),a6
		jsr	_LVOAddGList(a6)

	if	WithListView
		bsr.w	FillListViews2
		move.l	DTG_GadToolsBase(a5),a6
		move.l	Winhandle(a5),d0
		beq.s	.Return
		move.l	d0,a0
		suba.l	a1,a1
		jsr	_LVOGT_RefreshWindow(a6)

	endc

		move.l	WinHandle(a5),a0
		move.l	DTG_IntuitionBase(a5),a6
		jsr	_LVORefreshWindowFrame(a6)


.Return:	movem.l	(a7)+,d0-a6
		rts
		endc
		endc


*-----------------------------------------------------------------------------*
		if	inner_special
GetSizeToSpecial:pushlibs
		move.l	WinHandle(a5),d0
		beq.s	.Return
		move.l	d0,a0
		moveq	#0,d0
		sub.b	54(a0),d0
		sub.b	56(a0),d0
		ext.w	d0
		add.w	8(a0),d0

		moveq	#0,d1
		sub.b	55(a0),d1
		sub.b	57(a0),d1
		ext.w	d1
		add.w	10(a0),d1
		lea	EUS_Structure(pc),a0
		move.w	d0,EUS_Special(a0)
		move.w	d1,EUS_Special+2(a0)
.Return:	poplibs
		rts
		endc


*-----------------------------------------------------------------------------*
		if	EID_GadgetDown+EID_GadgetUp
CreateGadgets:	movem.l d1-a6,-(a7)
		move.l	DTG_IntuitionBase(a5),a6
	;	tst.l	Winhandle(a5)
	;	bne.w	.Return
		tst.l	MyFirstGadget(a5)
		bne.w	.Return

	*----------- z.B Koordinaten setzen -----------*
		bsrif	InitGadgetsStructs,InitGadgets

		lea	MyFirstGadget(a5),a4
* GA_Top setzen
* GA_Relheight setzen
* GA_Top setzen
	
		if	WithScrollBalkenRight
		lea	WithScrollBalkenRightTags(pc),a2
		move.l	SichtbarVert(a5),76(a2)
		move.l	SichtbarVertAll(a5),84(a2)

;		move.l	WinHandle(a5),a0
;		moveq	#0,d0
;		move.b	55(a0),d0
;		addq.w	#1,d0
;		move.l	d0,d5
;		move.l	d0,12(a2)		;Hhe setzen
;
;		moveq	#0,d0
;		move.b	56(a0),d0
;		subq.l	#6,d0
;		move.l	d0,28(a2)		;Breite setzen
;		subq.l	#2,d0
;		move.l	d0,20(a2)		;Links setzen
;
;		move.l	d5,d0
;		neg.l	d0
;	;	sub.b	57(a0),d0
;		sub.w	#11,d0
;		ext.w	d0
;		ext.l	d0
;		move.l	d0,36(a2)
;
;		moveq	#0,d0
;		sub.b	56(a0),d0
;		ext.w	d0
;		ext.l	d0
;		addq.l	#5,d0
;		move.l	d0,44(a2)

		lea	EPPropClass(pc),a1
		sub.l	a0,a0
		jsr	_LVONewObjectA(a6)	
		move.l	d0,ScrollObjectRight(a5)
		tst.l	d0
		beq.w	.Return
		move.l	d0,(a4)
		move.l	d0,a4
	move.l	(a4),d0
	endc

	*------------------ Nun Bottom-Balken adden ------------------*
		if	WithScrollBalkenBottom

		lea	WithScrollBalkenBottomTags(pc),a2
		move.l	SichtbarHori(a5),76(a2)
		move.l	SichtbarHoriAll(a5),84(a2)
;		move.l	WinHandle(a5),a0
;
;		moveq	#0,d0
;		move.b	57(a0),d0
;		addq.w	#1,d0
;	;	move.l	d0,12(a2)		;Hhe setzen
;
;		moveq	#0,d0
;		move.b	54(a0),d0
;		move.l	d0,28(a2)		;Breite setzen
;	;	sub.b	56(a0),d0
;		sub.w	#61,d0
;		ext.w	d0
;		ext.l	d0
;	;	move.l	d0,20(a2)		;Links setzen
;
;		move.b	57(a0),d0
;		neg.b	d0
;	;	sub.w	#11,d0
;		ext.w	d0
;		ext.l	d0
;	;	move.l	d0,36(a2)
;
;		moveq	#0,d0
;		sub.b	57(a0),d0
;		ext.w	d0
;		ext.l	d0
;		addq.l	#5,d0
;	;	move.l	d0,44(a2)


		lea	EPPropClass(pc),a1
		sub.l	a0,a0
		jsr	_LVONewObjectA(a6)	
		move.l	d0,ScrollObjectBottom(a5)
		tst.l	d0
		beq.w	.Return
		move.l	d0,(a4)
		move.l	d0,a4
	endc

	*------------- nun die normalen Gadgets createn ------------*
		move.l	PubScreenAdr(a5),a0
		move.l	SC_Font(a0),a1
		move.w	TA_YSize(a1),d3
		addq.w	#1,d3
		move.b	SC_WBorTop(a0),d0
		ext.w	d0
		add.w	d3,d0
		move.w	d0,OffY(a5)
		move.w	#3,OffX(a5)

		moveq	#0,d3
		moveq	#0,d2
	ifeq	inner_special
		move.w	#WindowInnerWidth,d2
		move.w	#WindowInnerHeight,d3
	else
		move.w	EUS_Structure+EUS_Special(pc),d2
		move.w	EUS_Structure+EUS_Special+2(pc),d3
	endc
		move.l	PubScreenAdr(a5),a0
		move.l	d2,d0
		move.l	d0,d4

		moveq	#0,d2
		add.w	d2,d0
		addq	#3,d0
		move.b	SC_WBorRight(a0),d1
		ext.w	d1
		add.w	d1,d0
		cmp.w	SC_Width(a0),d0
		bls.s	.WidthOk
		move.w	sc_Width(a0),d0
		sub.w	d4,d0
		move.w	d0,d2
.WidthOk:	move.l	d3,d0
		move.l	d0,d4

		move.w	EUS_Structure+EUS_Winy(pc),d3
		add.w	d3,d0

		add.w	OffY(a5),d0
		move.b	SC_WBorBottom(a0),d1
		ext.w	d1
		add.w	d1,d0
		cmp.w	sc_Height(a0),d0
		bls.s	.SetGPtr
		move.w	SC_Height(a0),d0
		sub.w	d4,d0
		move.w	d0,d3

	*-------------- GadgetList-Ptr festlegen --------------*
.SetGPtr:	move.l	DTG_GadToolsBase(a5),a6
		lea	WinGadgetsAdr(a5),a0		;aktueller Gadgetptr
		jsr	_LVOCreateContext(a6)
		move.l	d0,a3
		tst.l	d0
		beq	.Return
		moveq	#0,d3			;Ptr fr GadgetAdrTabelle
		lea	NewGadgetTags(pc),a4

*----- Dir Gadgets nun nacheinander in GadgetPuffer kopieren und dann ------*
*----------- ber GadTools eine ordentliche Struktur erzeugen --------------*
.NextGadget:	move.l	4.w,a6
		lea	NewGadgetStrukturen(pc),a0
		move.l	d3,d0				;Nummer des Gadgets
		mulu	#GNG_SizeOf,d0
		add.l	d0,a0
		lea	GadgetPuffer(a5),a1
		moveq	#GnG_SizeOf,d0
		jsr	_LVOCopyMem(a6)


	*--- in der neuen Structur nun die Koordinaten neu festlegen ---*
		lea	GadgetPuffer(a5),a0
		move.l	VisualInfo(a5),GNG_VisualInfo(a0)
	if AbsoluteFont
		move.l	Font(a5),gng_TextAttr(a0)
	endc
		move.w	OffX(a5),d0
		add.w	d0,GNG_LeftEdge(a0)
		move.w	OffY(a5),d0
		add.w	d0,GNG_TopEdge(a0)

	*----------------------- Gadget nun createn ---------------------*
		move.l	DTG_GadToolsBase(a5),a6
		lea	NewGadgetTypes(pc),a0
		moveq	#0,d0
		move.l	d3,d1
		asl.l	#1,d1
		add.l	d1,a0
		move.w	(a0),d0
		move.l	a3,a0
		lea	GadgetPuffer(a5),a1
		move.l	a4,a2
		jsr	_LVOCreateGadgetA(a6)
		tst.l	d0
		beq.s	.Return

	*-- tabelle anlegen, in der alle Gadgetadressen enthalten sind --*
.GadgetOk:	move.l	d0,a3
		move.l	d3,d0
		asl.l	#2,d0
		lea	GadgetDefinitionen(a5),a0
		add.l	d0,a0
		move.l	a3,(a0)

	*--------------- TagListEnde suchen-------------*
.FindLastTagItem:tst.l	(a4)
		beq.s	.IncGNr
		addq.l	#8,a4
		bra.s	.FindLastTagItem

.IncGNr:	addq.l	#4,a4
		addq.w	#1,d3
		cmp.w	#GadgetAnz,d3
		bmi	.NextGadget

	*---- ActivationsFlags eventuell neu setzen ----*
	*- nur fr Gadgets, die ein/ausschaltbar sind --*
;		lea	ActivationTab(pc),a2
;.NextGadgetActi:move.w	(a2)+,d0
;		beq.s	.FlagsIO
;		bsr	FindGadget			;Gadgetadresse in A0
;		move.w	GG_Activation(a0),d0
;		or.w	(a2)+,d0
;		move.w	d0,GG_activation(a0)
;		bra.s	.NextGadgetActi
;ActivationTab:	dc.w	0



	*--------------- 1. Gadgetende suchen-------------*
		lea	MyFirstGadget(a5),a0
.FindLastPtr:	tst.l	(a0)
		beq.s	.MyLastFound
		move.l	(a0),a0
		bra.s	.FindLastPtr
.MyLastFound:	move.l	WinGadgetsAdr(a5),(a0)

	;	bsrif	FillListViews,WithListview
	;	bsrif	ChangeGadgets,InitGadgets2

.Return:	movem.l	(a7)+,d1-a6
		move.l	MyFirstGadget(a5),d0
		rts
		endc


*-----------------------------------------------------------------------------*
		if	InitGadgets
InitGadgetsStructs:
	if	withlistview
		pushlibs
	if	EWF_SizeBright+EWF_SizeBottom
		bsrif	GetSizeToSpecial,Inner_Special
		lea	ListViewGadget+4(pc),a0

		if	Inner_Special
		move.l	EUS_Structure+EUS_Special(pc),d1
		else
		move.l	InnerKoordinaten(pc),d1		;Koor fr Default
		endc

.SetDefaults:	move.l	d1,(a0)				;Breite,Hhe setzen
		sub.w	#AbstandLinks*2,(a0)
		sub.w	#AbstandOben*2,2(a0)
		endc
	ifeq	EWF_SizeBright+EWF_SizeBottom
		tst.w	Kick3On(a5)
		bne.s	.Kick30
		move.w	#ListView20Height,ListViewGadget+6
	endc
.Kick30:	endc
		poplibs
		rts
		endc


*----------------------------------------------------------------------------*
	if withlistview
RefreshList:	pushlibs
		bsr.w	FillListViews
		move.l	DTG_GadToolsBase(a5),a6
		move.l	Winhandle(a5),d0
		beq.s	.Return
		move.l	d0,a0
		suba.l	a1,a1
		jsr	_LVOGT_RefreshWindow(a6)

.Return:	poplibs
		rts
	endc

*-----------------------------------------------------------------------------*
	if	Withlistview
FillListViews:	bsr.w	UpdateListViewList
FillListViews2:	movem.l	d0-a6,-(a7)
		move.l	DTG_GadToolsBase(a5),a6
		move.l	Winhandle(a5),d0
		beq.s	.Return
		move.l	d0,a1
		moveq	#NrListView,d0
		bsr	FindGadget			:NotFound

		move.l	Eintrage(a5),d0
		lea	ListViewTags(pc),a3
		lea	ListViewStruct(a5),a2
		move.l	a2,4(a3)
		move.w	ListViewNr(a5),14(a3)
		move.w	ListViewNr(a5),22(a3)
		sub.l	a2,a2
		jsr	_LVOGT_SetGadgetAttrsA(a6)

.Return:	movem.l	(a7)+,d0-a6
		rts
	endc

*-----------------------------------------------------------------------------*
	if	Withlistview
ClearListViews:	pushlibs
		move.l	DTG_GadToolsBase(a5),a6
		move.l	Winhandle(a5),d0
		beq.s	.Return
		move.l	d0,a1
		moveq	#NrListView,d0
		bsr	FindGadget

		lea	ListViewTags(pc),a3
		move.l	#-1,4(a3)
		clr.l	12(a3)
		clr.l	20(a3)
		sub.l	a2,a2
		jsr	_LVOGT_SetGadgetAttrsA(a6)

	;	bsr.w	RefreshMyWindow
.Return:	clr.w	ListViewNr(a5)
		poplibs
		rts
	endc

*----------------------------------------------------------------------------*
* Achtung: darauf achten, ob Gadgets vom Window removed wurden !!!!!! -------*
		if	EID_GadgetDown+EID_GadgetUp
FreeGadgets:	pushlibs
	;	tst.l	WinHandle(a5)			;nur freigeben, wenn
	;	bne.s	.Return				;Window zu ist

	*--------------- Nun die Gadgets freigeben -------------*
		move.l	DTG_GadToolsBase(a5),a6
		move.l	WinGadgetsAdr(a5),d0
		beq	.NoGadgets
		move.l	d0,a0
		clr.l	WinGadgetsAdr(a5)
		jsr	_LVOFreeGadgets(a6)
		lea	GadgetDefinitionen(a5),a0
		moveq	#GadgetAnz-1,d0
		blt.s	.NoGadgets
.ClrPtrs:	clr.l	(a0)+
		dbf	d0,.ClrPtrs

	*----------- Nun oberen ScrollBalken freigeben ---------*
.NoGadgets:	if	WithScrollBalkenRight+WithScrollBalkenBottom
		move.l	DTG_Intuitionbase(a5),a6
		endc
		if WithScrollBalkenRight
		move.l	ScrollObjectRight(a5),d0
		beq.s	.NoRight
		move.l	d0,a0
		clr.l	ScrollObjectRight(a5)
		jsr	_LVODisposeObject(a6)
		endc

	*---------- Nun unteren Scrollbalken entfernen ----------*
.NoRight:	if	WithScrollBalkenBottom
		move.l	ScrollObjectBottom(a5),d0
		beq.s	.NoBottom
		move.l	d0,a0
		clr.l	ScrollObjectBottom(a5)
		jsr	_LVODisposeObject(a6)
		endc

	*---------- Nun die normalen Gadgets freigeben ----------*
.NoBottom:	clr.l	MyFirstGadget(a5)
.Return:	poplibs
		rts
		endc


*-----------------------------------------------------------------------------*
		if	EID_GadgetDown+EID_GadgetUp
FindGadget:	lea	GadgetDefinitionen(a5),a0
		subq.l	#NrFirstGadget,d0
		lsl.l	#2,d0
		move.l	(a0,d0.w),a0
		lsr.l	#2,d0
		rts
		endc


*----------------------------------------------------------------------------*
*------		Public Screen ranholen und Visual Info anfordern	-----*
*----------------------------------------------------------------------------*
LockPubScreen:	pushlibs
		clr.l	VisualInfo(a5)
		move.l	EPBase(a5),a0
		move.l	EPG_Pubscreen(a0),a0
		move.l	DTG_Intuitionbase(a5),a6
		jsr	_LVOLockPubScreen(a6)
		move.l	d0,PubscreenAdr(a5)
		tst.l	d0
		beq.s	.Error

		move.l	PubscreenAdr(a5),a0
		move.l	DTG_GadToolsbase(a5),a6
		sub.l	a1,a1
		jsr	_LVOGetVisualInfoA(a6)
		move.l	d0,VisualInfo(a5)
		tst.l	d0
		beq.w	.Error
.Error:		poplibs
		move.l	VisualInfo(a5),d0
		rts

*----------------------------------------------------------------------------*
*------		Public Screen ranholen und Visual Info anfordern	-----*
*----------------------------------------------------------------------------*
FreePubScreen:	pushlibs
		move.l	DTG_GadToolsBase(a5),a6
		move.l	VisualInfo(a5),d0
		beq.s	.NoVisualInfo
		move.l	d0,a0
		clr.l	VisualInfo(a5)
		jsr	_LVOFreeVisualInfo(a6)
.NoVisualInfo:	move.l	DTG_Intuitionbase(a5),a6
		sub.l	a0,a0
		move.l	PubScreenAdr(a5),d0
		beq.s	.NoPub
		move.l	d0,a1
		clr.l	PubScreenAdr(a5)
		jsr	_LVOUnlockPubScreen(a6)
.NoPub:		poplibs
		rts


*-----------------------------------------------------------------------------*
*-----				Menustrip setzen			------*
*-----------------------------------------------------------------------------*
		if	EID_MenuPic
SetMenuStrip:	pushlibs
		tst.w	WinMenuOn(a5)
		bne.s	.NoMenus
		move.l	Winhandle(a5),d0
		beq.s	.NoMenus
		move.l	d0,a0
		move.l	WinMenuAdr(a5),d0
		beq.s	.NoMenus
		move.l	d0,a1
		move.l	DTG_Intuitionbase(a5),a6
		jsr	_LVOSetMenuStrip(a6)
		move.l	DTG_Gadtoolsbase(a5),a6
		move.l	Winhandle(a5),a0
		sub.l	a1,a1
		jsr	_LVOGT_RefreshWindow(a6)
		move.w	#1,WinMenuOn(a5)
.NoMenus:	poplibs
		rts
		endc

*-----------------------------------------------------------------------------*
*-----				Menustrip lschen			------*
*-----------------------------------------------------------------------------*
		if	EID_MenuPic
ClearMenuStrip:	pushlibs
		tst.w	WinMenuOn(a5)
		beq.s	.NoMenus
		move.l	Winhandle(a5),d0
		beq.s	.NoMenus
		move.l	d0,a0
		move.l	WinMenuAdr(a5),d0
		beq.s	.NoMenus
		move.l	d0,a1
		move.l	DTG_Intuitionbase(a5),a6
		jsr	_LVOClearMenuStrip(a6)
		move.l	DTG_Gadtoolsbase(a5),a6
		move.l	Winhandle(a5),a0
		sub.l	a1,a1
		jsr	_LVOGT_RefreshWindow(a6)
.NoMenus:	clr.w	WinMenuOn(a5)
		clr.w	ItemAddi(a5)
		poplibs
		rts
		endc


*-----------------------------------------------------------------------------*
		if	EID_MenuPic
CreateMenus:	movem.l	d1/a0-a2/a6,-(a7)

	*--------------- Menus erstellen -----------------*
		move.l	WinMenuAdr(a5),d0
		bne.s	.Return
		move.l	DTG_GadToolsBase(a5),a6
		lea	MyMenus(pc),a0
		lea	MenuTags(pc),a1
		jsr	_LVOCreateMenusA(a6)
		move.l	d0,WinMenuAdr(a5)
		tst.l	d0
		beq.s	.Return

	*------------ Menu dem Screen anpassen -----------*
		move.l	d0,a0
		move.l	VisualInfo(a5),d0
		beq.s	.Return
		move.l	d0,a1
		lea	MenuTags(pc),a2
		jsr	_LVOLayoutMenusA(a6)
		tst.l	d0
		bne.s	.Return

	*------------ Menus wieder freigeben -------------*
		move.l	WinMenuadr(a5),a0
		clr.l	WinMenuadr(a5)
		jsr	_LVOFreemenus(a6)


.Return:	movem.l	(a7)+,d1/a0-a2/a6
		tst.l	d0
		rts
		endc

*-----------------------------------------------------------------------------*
		if	EID_MenuPic
FreeMenus:	pushlibs
		move.l	WinMenuAdr(a5),d0
		beq.s	.Return
		clr.l	WinMenuAdr(a5)
		move.l	d0,a0
		bsr.w	ClearMenuStrip
		move.l	DTG_GadToolsBase(a5),a6
		jsr	_LVOFreeMenus(a6)
.Return:	poplibs
		rts
		endc




	*----- Hintergrundpattern fr Schraffierungen ------*
		if	raster
FillMuster1:	dc.w	%1010101010101010
		dc.w	%0101010101010101
FillMuster2:	dc.w	0,0
		endc

*-----------------------------------------------------------------------------*
		if	WithScrollBalkenRight
WithScrollBalkenRightTags:
.4		dc.l	GA_ID,2
.12		dc.l	GA_Top,12		;Hhe des ScreenFonts
.20		dc.l	GA_Width,10
.28		dc.l	GA_Left,12
.36		dc.l	GA_RelHeight,-13-12
.44		dc.l	GA_RelRight,-12
.52		dc.l	GA_RightBorder,1
.60		dc.l	GA_Immediate,1
.68		dc.l	PGA_Freedom,Freevert
.76		dc.l	PGA_Total,20		;MessageNum
.84		dc.l	PGA_Visible,5		;Anzahl fr ScrollBalken
		dc.l	PGA_Top,0		;soll 0 sein
		dc.l	PGA_NewLook,1
		dc.l	0
		endc

		if	WithScrollBalkenBottom
WithScrollBalkenBottomTags:
.4		dc.l	GA_ID,2
.12		dc.l	GA_Top,0		;Wert egal
.20		dc.l	GA_Height,6
.28		dc.l	GA_Left,2
.36		dc.l	GA_RelWidth,-13-12
.44		dc.l	GA_RelBottom,-7
		dc.l	GA_BottomBorder,1
		dc.l	GA_Immediate,1
		dc.l	PGA_Freedom,Freehoriz
		dc.l	PGA_Total,12		;MessageNun
		dc.l	PGA_Visible,10		;Anzahl fr ScrollBalken
		dc.l	PGA_Top,0		;soll 0 sein
		dc.l	PGA_NewLook,1
		dc.l	0
		endc


	*--------- Definitionien fr EasyStruct ------------*
		ifeq	executable+debugger
About_EasyStruct:dc.l	0
		dc.l	0
		dc.l	MYEasyTitle
		dc.l	AboutUPrg.MSG		;AboutRequester
		dc.l	EG_Ok
		else
About_Gadgets:	dc.l	0,EG_Ok
		dc.b	"Oo",10,13
		endc

EPFind_EasyStruct:dc.l	0
		dc.l	0
		dc.l	MyEasyTitle
		dc.l	EPPortNotFound		;Cannot find Eagleplayerport
		dc.l	EG_RetryCancel

ScreenTitle:	dc.b	"Eagleplayer Userprogram",0
MyCreatorname:	dc.b	"Eagleeye of DEFECT",0
EPUserPortname:	dc.b	"EAGLEPLAYERPORT",0
		if	WithScrollBalkenRight+WithScrollBalkenBottom
EPPropClass:	dc.b	"propgclass",0
		endc
EPPortNotFound:	dc.b	"Cannot find EaglePlayer Port",0
Kickstart20Text:dc.b	"This Userprogram needs Amiga-OS2.04 or higher to run !!!",0
Kickstart20TextLen	= *-Kickstart20Text
EG_Ok:		dc.b	"   OK   ",0
EG_RetryCancel:	dc.b	" Retry | Cancel ",0
;EG_YesNo:	dc.b	"Yes|Cancel",0
		even
;;
