*****************************************************************************
**  (C) Henryk "Buggs" Richter ,all copyright notices have to stay intact  **
**  Needs ASM-One 1.29 !                                                   **
**                               25.01.96                                  **
*****************************************************************************
	;
	;
	incdir	include:
	include	exec/exec_lib.i
	include	dos/dos_lib.i
	include	datatypes/datatypes.i
	include	datatypes/soundclass.i
	include	libraries/datatypes_lib.i
	include	misc/buggsmacros.i
	include	"misc/EaglePlayer.i"
	include	"misc/EaglePlayerengine.i"
	;
	section	0,code_p
	;
ver	macro
	dc.b	"0.85"
	endm
date	macro
	dc.b	"10.09.97"
	endm
structver	macro
		dc.w	0,85
		endm
	;
ChipSize	equ	2040	;durch 3 & durch 4 teilbar (ADPCM Vorbereitung)
	;
	section	0,code

	EPPHEADER PlayerTags

	dc.b '$VER: Datatype Eagleplayer V'
	ver
	dc.b	'('
	date
	dc.b	`)`,0
	even

PlayerTags
Tags:	
	dc.l	EP_PlayerVersion,Eagleversion
	dc.l	EP_Flags,EPB_Moduleinfo!EPB_VolVoices!EPB_Save!EPB_Restart!EPB_Songend!EPB_Volume!EPB_Balance!EPB_Voices!EPB_Analyzer
	dc.l	DTP_PlayerVersion
	structver
	dc.l	DTP_PlayerName,DT_Name
	dc.l	DTP_Creator,DT_Buggs
;	dc.l	DTP_Check1,TestDT
	dc.l	EP_Check6,TestDT

	dc.l	DTP_InitPlayer,Initplay
	dc.l	DTP_EndPlayer,Endplay

	dc.l	DTP_InitSound,initsound

	dc.l	DTP_Startint,StartPlay
	dc.l	DTP_Stopint,StopPlay

	dc.l	DTP_Volume,SetVoices
	dc.l	DTP_Balance,SetVoices
	dc.l	EP_Voices,SetVoices

	dc.l	EP_SetSpeed,Speedit

	dc.l	EP_NewModuleInfo,DT_InfoBuffer

	dc.l	EP_InitAmplifier,InitAudstruct

	dc.l	EP_SampleInit,DT_SampleInit
	dc.l	0

DT_Firstsinfo:	dc.l	0
DT_Name		dc.b	`Datatype`,0
DT_Buggs	dc.b	`Buggs of Defect`,0
dtypes:		dc.b	`datatypes.library`,0
dtname		dc.b	` Datatype`,0
Samplename	dc.b	`unknown name`,0
namebuffer1:	ds.b	30
namebuffer2:	ds.b	40
ahatext:	dc.b	`NB: The shown size of this sample`,10
		dc.b	`    is the size returned by the`,10
		dc.b	`    datatype. It is not the size `,10
		dc.b	`    of the original Sample.`,0
	even
DT_InfoBuffer:	
	dc.l	MI_Samples,1			;4
	dc.l	MI_Soundsystem,namebuffer2	;12
	dc.l	MI_Duration,0			;20
	dc.l	MI_Calcsize,0			;28
	dc.l	MI_ExtraInfo,Ahatext		;36
	dc.l	MI_Playfrequency,0		;44
	dc.l	0
;----------------------------------------------------------------------------------------------------
DT_Sampleinit:
		moveq	#EPR_NotEnoughMem,d7

		move.l	DT_Sampleadr(pc),d0
		beq	.Return
		move.l	DT_Samplelen(pc),d1

		lea	DT_FirstSInfo(pc),a3
		jsr	ENPP_AllocSampleStruct(A5);Frischer leerer Speicher !!!
		move.l	d0,(a3)
		beq.s	.Return
		move.l	d0,a3

		move.l	#Samplename,EPS_SampleName(a3)
		move.l	DT_Sampleadr(pc),EPS_Adr(a3)

		move.l	DT_Samplelen(pc),EPS_Length(a3)

		clr.w	EPS_Finetune(a3)

		move.l	#64,EPS_Volume(a3)

		clr.l	EPS_Replen(a3)
		clr.l	EPS_Repeat(a3)

		move.w	#3!USIB_8Bit,EPS_Flags(a3)
		move.w	#10,EPS_MaxNameLen(a3)

		moveq	#0,d7			;Kein Error
.Return:	move.l	d7,d0
		move.l	DT_FirstSInfo(pc),EPG_SampleInfoStructure(a5)
		rts

;----------------------------------------------------------------------------------------------------
Speedit:
	move.l	DT_SamplePer(pc),d1
	muls	d1,d0			;Speed*Per
	divs	#25*4,d0		;durch Maxwert (25% der Periode)
	sub	d0,d1

	cmp	#64,d1
	bge.s	.take
	moveq	#64,d1
.take	move	d1,d0
	lea	$dff0a0,a5
	bsr	PokePer
	lea	$10(a5),a5
	bsr	PokePer
	rts
;============================ Get Infos (Create InfoTag-Itemliste) =================================
GetInfos:
;	move.l	DTObject(pc),d0
;	beq.s	.noOB
	
	lea	namebuffer1(pc),a0
	lea	namebuffer2(pc),a1
	moveq	#30-1,d0
.copy
	move.b	(a0)+,(a1)+
	dbeq	d0,.copy
	subq.l	#1,a1
	lea	dtname(pc),a0
.copy2	move.b	(a0)+,(a1)+
	bne.s	.copy2
	
	lea	DT_Infobuffer(pc),a0
	
	move.l	DT_SamplePer(pc),d0	;Abspielfrequenz = Audiorate/Periode
	move.l	#3546895,d1
	divu	d0,d1
	and.l	#$ffff,d1
	move.l	d1,44(a0)

	move.l	DT_Samplelen(pc),d0
	move.l	d0,28(a0)

	divu	d1,d0			;Spielzeit = Samplelnge / Abspielfrequenz

	swap	d0			;Ergebnis runden
	lsr	#1,d1			;Divisor/2
	sub	d1,d0
	blt.s	.noadd
	swap	d0
	addq	#1,d0
	bra.s	.skip
.noadd	swap	d0
.skip	and.l	#$ffff,d0
	move.l	d0,20(a0)
.noOB	rts
;----------------------------------------------------------------------------------------------------
InitAudstruct:
	move.l	#EPAMB_AudioInts!EPAMB_Direct!EPAMB_8Bit,d7
	
	move.l	d7,NPFlags

	lea	Audstruct0,a0		;Audio Struktur vorbereiten

	lea	(a0),a1
	move.w	#as_sizeof*2-1,d0
.clr	clr.b	(a1)+
	dbf	d0,.clr

	move.w	#01,AS_Leftright(a0)			;1. Kanal links
	move.w	#-1,AS_Leftright+as_sizeof*1(a0)	;2. Kanal rechts

	move.l	#AudioINT,AS_Int(a0)

	lea	AudTagliste(pc),a0
	move.l	a0,EPG_Amplifiertaglist(a5)

	moveq	#0,d0
Setvoices
	rts
.err
	moveq	#-1,d0
myrts
	rts

AudTagliste
	dc.l	EPAMT_Numstructs,2
	dc.l	EPAMT_Audiostructs,Audstruct0
	dc.l	EPAMT_Flags
NPFlags
	dc.l	0
	dc.l    TAG_DONE,0
;----------------------------------- Checkroutine ------------------------------------------------
TestDT
	bsr	OpenLibs
	beq.s	.noDT

	move.l	dtg_PathArrayPtr(a5),a0
	clr.b	(a0)			; clear Path
	jsr	ENPP_CopyDir(a5)
	jsr	ENPP_CopyFile(a5)

	move.l	dtg_DOSBase(A5),a6
	move.l	dtg_PathArrayPtr(a5),d1
	moveq	#-2,d2
	jsr	_LVOLock(a6)			;File Lock
	move.l	d0,d7
	beq.s	.noDT

	move.l	d0,a0				;BPTR Filelock
	moveq	#DTST_File,d0			;Typ
	suba.l	a1,a1				;Tags
	move.l	datatypes(pc),a6		;Lib Base
	jsr	_LVOObtainDatatypeA(A6)
	tst.l	d0
	beq.s	.unlock
	move.l	d0,a0
	move.l	dtn_Header(a0),a1
	move.l	dth_GroupID(a1),d6		;Identifier fr Gruppe
	move.l	dth_Name(a1),d0
	beq.s	.oops
	move.l	d0,a1
	lea	namebuffer1(pc),a2		;Name of the Datatype
	moveq	#30-1,d0
.copy	move.b	(a1)+,(a2)+
	dbf	d0,.copy
.oops
	move.l	datatypes(pc),a6		;Lib Base
	jsr	_LVOReleaseDatatype(A6)

	move.l	d7,d1
	move.l	dtg_DOSBase(A5),a6
	jsr	_LVOUnlock(A6)

	cmp.l	#GID_Sound,d6
	bne.s	.noDT
						;Lib offen lassen, brauchen wir eh noch
	moveq	#0,d0
	rts
.unlock	move.l	d7,d1
	move.l	dtg_DOSBase(A5),a6
	jsr	_LVOUnlock(A6)
.noDT	moveq	#-1,d0
	rts
;--------------------------------------------------------------------------------------------------
Initplay:
	push	d1-a6
	move.l	a5,EPBase

	bsr	OpenLibs
	beq	.errorinit

	move.l	dtg_PathArrayPtr(a5),a0
	clr.b	(a0)			; clear Path
	move.l	dtg_CopyDir(a5),a0	; copy dir into patharray
	jsr	(a0)
	move.l	dtg_CopyFile(a5),a0	; append filename
	jsr	(a0)
	move.l	dtg_PathArrayPtr(a5),d0
	lea	mytags(pc),a0
	move.l	#DTA_GroupID,(A0)+
	move.l	#GID_Sound,(a0)+
	clr.l	(A0)
	lea	mytags(pc),a0
	move.l	Datatypes(pc),a6
	jsr	_LVONewDTObjecta(A6)
	move.l	d0,DTObject
	beq.s	.errorinit
	move.l	d0,a0
	lea	mytags(pc),a2
	move.l	#SDTA_Sample,(A2)+
	lea	DT_Sampleadr(pc),a1
	move.l	a1,(a2)+
	move.l	#SDTA_SampleLength,(A2)+
	lea	DT_Samplelen(pc),a1
	move.l	a1,(a2)+
	move.l	#SDTA_Period,(A2)+
	lea	DT_SamplePer(pc),a1
	move.l	a1,(a2)+
	clr.l	(A2)+
	lea	mytags(pc),a2
	jsr	_LVOGetDTAttrsA(A6)
	cmp.w	#3,d0
	bne	.errorinit

	bsr	GetInfos

	pop	d1-a6
	moveq	#0,d0
	rts
.errorinit
	bsr	Endplay
	pop	d1-a6
	moveq	#-1,d0
	rts
;--------------------------------------------------------------------------------------------------
Endplay:
	push	all

	move.l	DTObject(pc),d0
	beq.s	.noOB
	move.l	d0,a0
	move.l	Datatypes(pc),a6		;Wenn DTObjekt, dann auch DTLib...
	jsr	_LVODisposeDTObject(A6)
	clr.l	DTObject
	clr.l	DT_Sampleadr
	clr.l	DT_Samplelen
.noOB
	bsr	Closelibs
	pop	all
	moveq	#0,d0
	rts
;--------------------------------------------------------------------------------------------------
InitSound:
	move.l	DT_Sampleadr(pc),d0
	move.l	DT_Samplelen(pc),d1

	move.l	d0,my_sampleadr
	move.l	d0,my_Currentadr
	move.l	d1,my_samplelen
	moveq	#0,d0
	rts
;--------------------------------------------------------------------------------------------------
Openlibs:
	push	d1-a6
	move.l	datatypes(pc),d0	;Lib schon offen ?
	bne.s	.fehler
	move.l	4.w,a6
	moveq	#39,d0
	lea	dtypes(pc),a1
	jsr	_LVOOpenlibrary(A6)
	move.l	d0,Datatypes
	beq.s	.fehler
	moveq	#1,d0
.fehler	pop	d1-a6
	rts
;--------------------------------------------------------------------------------------------------
Closelibs:
	push	all
	move.l	4.w,a6
	move.l	Datatypes,d0
	beq.s	.noDtype
	move.l	d0,a1
	jsr	_LVOcloselibrary(A6)
	clr.l	Datatypes
.noDtype
	pop	all
	rts
;--------------------------------------------------------------------------------------------------
StartPlay:
	moveq	#$3,d0
	bsr	PokeDMA

	lea	ChipBuffer,a0
	lea	(a0),a1
	move	#ChipSize*2/4-1,d0
.clr	clr.l	(a1)+
	dbf	d0,.clr

	lea	$dff0a0,a5
	move.l	a0,D0
	bsr	PokeAdr
	move	#ChipSize/2,d0
	bsr	PokeLen
	move.l	DT_SamplePer(pc),d0
	bsr	PokePer
	moveq	#64,d0
	bsr	PokeVol

	lea	$dff0b0,a5
	move.l	a0,D0
	bsr	PokeAdr
	move	#ChipSize/2,d0
	bsr	PokeLen
	move.l	DT_SamplePer(pc),d0
	bsr	PokePer
	moveq	#64,d0
	bsr	PokeVol

	move	#ChipSize,nextchipbuf

	st	waitplay

	move	#$8003,d0
	bsr	PokeDMA
	moveq	#0,d0
	rts
Stopplay:
	moveq	#$3,d0
	bsr	PokeDMA
	moveq	#0,d0
	rts

*----------------------------------------------------------------------------*
INT_Aud:
	push	all
	move.b	waitplay(pc),d0
	bne	not$

	moveq	#0,d0
	move	nextchipbuf(pc),d0
	lea	ChipBuffer,a0
	add.l	d0,a0
	eor.w	#ChipSize,d0
	move	d0,nextchipbuf

	move.l	EPBase,a5
	move.l	a0,d0
	moveq	#0,d1
	jsr	ENPP_PokeAdr(a5)
	addq	#1,d1
	jsr	ENPP_PokeAdr(a5)

	move	#chipsize-1,d0
	move.l	my_Currentadr(pc),d1
	move.l	d1,a1
	sub.l	my_Sampleadr(pc),d1
	move.l	my_samplelen(pc),d2
	sub.l	d1,d2
	ble.s	.restart
	cmp.l	#chipsize,d2
	bge.s	.spiel
.copyrest
	move.b	(a1)+,(a0)+
	subq.w	#1,d2
	blt.s	.restart
.jumpin
	dbf	d0,.copyrest
	move.l	a1,my_Currentadr

not$
	clr.b	waitplay
	pop	all
	rts
.restart
	move.l	my_sampleadr(pc),a1
	move.w	#chipsize,d2

	move.l	EPbase(pc),a2
	move.l	dtg_SongEnd(a2),a2
	jsr	(a2)		;End of Song for Playerprogram

	bra.s	.jumpin
.spiel
	move	#chipsize/4-1,d0
.copy	move.l	(a1)+,(a0)+
	dbf	d0,.copy
	move.l	a1,my_Currentadr
	pop	all
	rts
PokeVol:			;in D0 Lautstrke
	movem.l	d1/a5,-(sp)
	move.w	a5,d1		;Dff0a0/b0/c0/d0
	sub.w	#$f0a0,d1
	lsr.w	#4,d1		;Nummer der Stimme von 0-3
	move.l	EPBase,a5
	jsr	ENPP_Pokevol(a5)
	movem.l	(sp)+,d1/a5
	rts
PokePer:			;in D0 Periodenwert
	movem.l	d1/a5,-(sp)
	move.w	a5,d1		;Dff0a0/b0/c0/d0
	sub.w	#$f0a0,d1
	lsr.w	#4,d1		;Nummer der Stimme von 0-3
	and.w	#$f,d1
	move.l	EPBase,a5
	jsr	ENPP_PokePer(a5)
	movem.l	(sp)+,d1/a5
	rts
PokeLen:			;in D0 Lnge in Worten
	movem.l	d1/a5,-(sp)
	move.w	a5,d1		;Dff0a0/b0/c0/d0
	sub.w	#$f0a0,d1
	lsr.w	#4,d1		;Nummer der Stimme von 0-3

	and.l	#$ffff,d0

	move.l	EPBase,a5
	jsr	ENPP_PokeLen(a5)

	movem.l	(sp)+,d1/a5
	rts
PokeAdr:			;in D0 Adresse
	movem.l	d1/a5,-(sp)
	move.w	a5,d1		;Dff0a0/b0/c0/d0
	sub.w	#$f0a0,d1
	lsr.w	#4,d1		;Nummer der Stimme von 0-3

	move.l	EPBase,a5
	jsr	ENPP_PokeAdr(a5)

	movem.l	(sp)+,d1/a5
	rts
PokeDMA:
	movem.l	d1/d2/a5,-(sp)
	move.l	EPBase,a5

	move.w	d0,d1
	and.w	#$8000,d0	;D0.w neg=enable ; 0/pos=disable
	and.l	#15,d1		;D1 = Maske (LONG !!)

	jsr	ENPP_DmaMask(a5)

	movem.l	(sp)+,d1/d2/a5
	rts
nextchipbuf	dc.w	0
my_Currentadr	dc.l	0
my_sampleadr	dc.l	0
my_samplelen	dc.l	0
Datatypes	dc.l	0
mytags:		ds.l	20*2
DTObject	dc.l	0
DT_Sampleadr	dc.l	0
DT_Samplelen	dc.l	0
DT_SamplePer	dc.l	0
vol_L		dc.w	0
vol_R		dc.w	0
EPBase		dc.l	0
waitplay	dc.b	0,0


AudioINT:
	dc.l	0			;letzter Node
	dc.l	0			;nchster Node
	dc.b	2			;Node Type = Interrupt
	dc.b	1			;Prioritt
	dc.l	0			;Name
	dc.l	0			;Zeiger auf Daten
	dc.l	INT_Aud			;Interrupt Routine

Audstruct0	ds.b	as_sizeof*4	;*4 nur zur Sicherheit, man weiss ja nie bei Betas

		section	2,bss_c
ChipBuffer:	ds.b	ChipSize	;\_ immer zusammen lassen !
ChipBuffer2:	ds.b	ChipSize	;/
