		IFND	LIBRARIES_ASYNCIO_I
LIBRARIES_ASYNCIO_I	SET	1

;*****************************************************************************

		IFND	EXEC_TYPES_I
			include "exec/types.i"
		ENDC

		IFND	EXEC_PORTS_I
			include "exec/ports.i"
		ENDC

		IFND	DOS_DOS_I
			include "dos/dos.i"
		ENDC

		IFND	DOS_DOSEXTENS_I
			include "dos/dosextens.i"
		ENDC

;*****************************************************************************


;This structure is public only by necessity, don't muck with it yourself, or
;you're looking for trouble
;
	
    STRUCTURE AsyncFile,0
	BPTR			af_File
	ULONG			af_BlockSize
	APTR			af_Handler
	APTR			af_Offset
	LONG			af_BytesLeft
	ULONG			af_BufferSize
	STRUCT			af_Buffers,8
	STRUCT			af_Packet,68		;sp_SIZE0F
	STRUCT			af_PacketPort,mp_SIZE
	ULONG			af_CurrentBuf
	ULONG			af_SeekOffset

	IFD	ASIO_NOEXTERNALS
		APTR		af_SysBase
		APTR		af_DOSBase
	ENDC

	UBYTE			af_PacketPending
	UBYTE			af_ReadMode
	UBYTE			af_CloseFH
	UBYTE			af_SeekPastEOF
	ULONG			af_LastRes1
	ULONG			af_LastBytesLeft

;*****************************************************************************

;open modes
MODE_READ	equ	0		;read an existing file
MODE_WRITE	equ	1		;create a new file, delete existing file if needed
MODE_APPEND	equ	2		;append to end of existing file, or create new

;seek modes
MODE_START	equ	-1		;relative to start of file
MODE_CURRENT	equ	0		;relative to current file position
MODE_END	equ	1		;relative to end of file

;*****************************************************************************

		ENDC		;ASYNCIO_I
